<i18n>
{
  "fr": {
    "title-1": "Les achats de biens et de services",
    "title-2": "Suppression",
    "title-3": "Extraction des données achats par l'utilisateur",
    "modal-title-1": "Modifier un achat",
    "modal-title-2": "Ajouter un achat",
    "modal-title-3": "Visualiser un achat",
    "info-1": "Veuillez téléverser la liste de vos achats financées sur crédits du laboratoire en",
    "info-2": ", toutes tutelles confondues, au format .tsv",
    "info-3": "exemple",
    "info-4": "Ce fichier doit contenir un item par ligne, avec les deux colonnes suivantes :",
    "info-5": "<strong>« Code NACRES »</strong> : identifiant suivant la <em>Nomenclature Achats Recherche Enseignement Supérieur</em> (<a target='_blank' class='link' href='https://www.amue.fr/presentation/presentation-amue/centrale-dachats/'>NACRES</a>). Formats NA.01 et NA01 acceptés.",
    "info-6": "<strong>« Montant »</strong> : le montant hors taxe de la dépense pour le code NACRES. Format numérique avec '.' pour séparer les décimales et sans espace : 1234.56.",
    "info-7": "Pour empêcher les doubles comptages, les codes NACRES qui correspondent à des achats dont les émissions sont calculées dans d’autres modules de <em>GES 1point5</em> ne sont pas pris en compte dans le module achats (cf « Autres modules » dans le tableau ci-dessous). Il s’agit des billets pour les déplacements professionnels, des combustibles pour les véhicules et le chauffage, et du matériel informatique. Le nombre de lignes valides correspond au nombre de lignes de code Nacres entrant dans le calcul des émissions des achats.",
    "info-8": "Téléverser un fichier (.tsv)",
    "info-9": "Des achats ne sont pas valides, continuer va entraîner leur suppression. <br /> Êtes vous sûr de vouloir continuer ?",
    "info-10": "Notez que le module « Les achats » est actuellement en mode test et que les facteurs d'émission et incertitudes peuvent donc changer.",
    "info-11": "Vous trouverez",
    "info-12": "ici",
    "info-13": "une explication pour extraire ces données pour les tutelles de votre laboratoire.",
    "label-1": "Montant total",
    "label-2": "Lignes valides",
    "label-3": "Autres modules",
    "label-4": "Synthèse du fichier",
    "label-5": "Synthèse Globale",
    "message-1": "Format de fichier invalide",
    "message-2": "<div class='content'><p>Le séparateur de colonnes doit être l'un des caractères suivants : <code>,</code>, <code>;</code>, <code>\t</code>.</p></div>",
    "message-3": "Fichier invalide",
    "message-4": "<div class='content'>Nous avons rencontré les problèmes suivants :<ul><li>Colonne <strong>« Code NACRES »</strong> manquante ou non reconnue.</li><li>Colonne <strong>« Montant »</strong> manquante ou non reconnue.</li></ul><p>Cela peut venir d'un mauvais nommage des colonnes, ou bien d'un mauvais formattage du fichier.</p></div>",
    "message-5": "Fichier dupliqué",
    "message-6": "Un fichier avec le même nom a déjà été importé dans <em>GES 1point5</em>.",
    "message-7": "Suppression",
    "message-8": "Êtes vous sûr de vouloir supprimer les données du fichier",
    "message-9": "Êtes vous sûr de vouloir supprimer l'ensemble des données ?",
    "save-msg": "Les informations d'achats ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>."
  },
  "en": {
    "title-1": "Purchases of goods and services",
    "title-2": "Delete",
    "title-3": "Extraction of purchases data by the user",
    "modal-title-1": "Edit a purchase",
    "modal-title-2": "Add a purchase",
    "modal-title-3": "View a purchase",
    "info-1": "Please upload the list of your purchases that were paid by your laboratory in",
    "info-2": ", all supervisory included, as a .tsv file",
    "info-3": "example",
    "info-4": "This file must contain one item per row, with the two following columns:",
    "info-5": "<strong>« NACRES code »</strong>: identifier according to the <em>Nomenclature Achats Recherche Enseignement Supérieur</em> (<a target='_blank' class='link' href='https://www.amue.fr/presentation/presentation-amue/centrale-dachats/'>NACRES</a>). Both formats NA.01 and NA01 are accepted.",
    "info-6": "<strong>« Amount »</strong>: the amount excluding VAT of the expense for the NACRES code. Numerical format with '.' to separate decimals and without space: 1234.56.",
    "info-7": "To prevent double counting, NACRES codes that correspond to purchases whose emissions are calculated in other <em>GES 1point5</em> modules are not included in the « Purchases of goods and services » module (they are included in « Other modules » in the table below). These are tickets for business travel, fuel for vehicles and heating, and digital devices. The number of valid rows corresponds to the number of Nacres code rows used in the calculation of emissions from purchases.",
    "info-8": "Upload a file (.tsv)",
    "info-9": "Some purchases data are not valid. If you continue to proceed, they will be deleted. <br />Are you sure you want to proceed?",
    "info-10": "Note that the « Purchases » module is currently in test mode and therefore emission factors and uncertainties may change.",
    "info-11": "An explanation of how to extract these data for your laboratory's supervisory bodies can be found ",
    "info-12": "here",
    "info-13": ".",
    "label-1": "Total amount",
    "label-2": "Valid rows",
    "label-3": "Other modules",
    "label-4": "File overview",
    "label-5": "Overview",
    "message-1": "Invalid file format",
    "message-2": "<div class='content'><p>The column separator must be one of the following characters: <code>,</code>, <code>;</code>, <code>\t</code>.</p></div>",
    "message-3": "Invalid file",
    "message-4": "<div class='content'>The tool identified the following issues: <ul><li><strong>« NACRES code »</strong> column missing or not found.</li><li><strong>« Amount »</strong> column missing or not found.</li></ul><p>This might be explained by a bad naming of the columns, or a bad formatting of the file.</p></div>",
    "message-5": "Duplicate file",
    "message-6": "A file with the same name has already been imported into <em>GES 1point5</em>.",
    "message-7": "Delete",
    "message-8": "Are you sure that you want to delete the data uploaded from the file ",
    "message-9": "Are you sure that you want to delete all data?",
    "save-msg": "The data relating to purchases have been <strong><span style='color:green;'>successfully</span></strong>saved."
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur"/>
    <su-service :icon="'eur'">
      <template #title>
        {{ $t('title-1') }}
      </template>
      <div class="content">
        <p>
          {{ $t('info-1') }} <strong> {{ currentYear }}</strong>{{ $t('info-2') }}
          (<a href="/static/carbon/purchasesTemplate.tsv" download>{{ $t('info-3') }}</a>).
          {{ $t('info-4') }}
        </p>
        <ul>
          <li v-html="$t('info-5')"></li>
          <li v-html="$t('info-6')"></li>
        </ul>
        <span v-html="$t('info-7')" />
        <br />
        {{ $t('info-11') }} <a @click="displayNote=true">{{ $t('info-12') }}</a> {{ $t('info-13') }}
        <br /><br />
        <b-tag rounded type="is-info">{{ $t('early.access') }}</b-tag> : <span v-html="$t('info-10')" />
      </div>
    </su-service>
    <br />
    <b-modal
      :active.sync="displayNote"
      has-modal-card
    >
      <div class="modal-card" style="width: 900px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">
            {{ $t('title-3') }}
          </p>
        </header>
        <section class="modal-card-body">
          <purchases-file-extraction :header="false" />
        </section>
      </div>
    </b-modal>
    <purchases-warning ref="purchasesWarning" />
    <div class="columns">
      <div class="column">
        <b-notification
          :closable="false"
        >
          <b-field>
            <b-select expanded v-model="currentFile">
              <option v-for="(file,key) in allFiles" :key="key" :value="file.filename">
                <template v-if="key !== 0">{{ $t('label-4') }} </template>
                {{ file.filename }}
              </option>
            </b-select>
            <p class="control">
              <b-button
                :disabled="submitted"
                @click="del"
                icon-left="trash"
              />
            </p>
          </b-field>
        </b-notification>
        <div class="columns">
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-1') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span>{{ totalAmount | splitFloat }} €</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-2') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span>{{ totalValid | splitNumber }} / {{ (totalValid + totalInvalid) | splitNumber }}</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    {{ $t('label-3') }}
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span>{{ totalOtherModules | splitNumber }} </span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
        </div>
      </div>
      <div class="column is-4 is-flex is-vcentered">
        <b-upload
          :disabled="submitted"
          v-model="dropFile"
          drag-drop
          expanded
          type="is-info"
        >
          <section class="section">
            <div class="content has-text-centered">
              <p>
                <span class="icon">
                  <i style="font-size: 36px" class="sui sui-upload"></i>
                </span>
              </p>
              <p>{{ $t('info-8') }}</p>
            </div>
          </section>
        </b-upload>
      </div>
    </div>
    <br />

    <purchases-table @edit="edit" @del="forceComputation" />

    <b-modal
      :active="displayModal"
      has-modal-card
      @close="closeModal"
      :can-cancel="['escape', 'x', 'outside']"
    >
      <div class="modal-card" style="width: 1000px; height: auto">
        <header class="modal-card-head">
          <p class="modal-card-title">{{ modalTitle }}</p>
        </header>
        <section class="modal-card-body">
          <purchase-form
            :purchase="purchase"
            :modeCreation="modeCreation"
            @close="closeModal"
            @add="add"
            @update="update"
          />
        </section>
      </div>
    </b-modal>

    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            :disabled="submitted"
            @click="displayAddForm()"
          >
            {{ $t('add') }}
          </b-button>
          <b-button
            class="level-item"
            :icon-left="validSavedIcon"
            :disabled="!module.isModified"
            type="is-primary"
            @click="validate()"
          >
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import Purchase from '@/models/carbon/Purchase.js'
import { purchasesParser } from '@/mixins/purchasesParser'
import { mapGetters } from 'vuex'

export default {
  name: 'Purchases',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'purchase-form': () => import('@/components/carbon/forms/PurchaseForm.vue'),
    'purchases-warning': () => import('@/components/carbon/forms/PurchasesWarning.vue'),
    'purchases-table': () => import('@/components/carbon/forms/PurchasesTable.vue'),
    'purchases-file-extraction': () => import('@/components/carbon/docs/PurchasesFileExtraction.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  mixins: [purchasesParser],
  data () {
    return {
      modeCreation: false,
      displayModal: false,
      displayNote: false,
      purchase: null,
      dropFile: {},
      currentFile: this.$t('label-5'),
      allFiles: [
        {
          'filename': this.$t('label-5')
        }
      ]
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    currentYear () {
      return this.$store.getters['ghgi/item']['year']
    },
    module: function () {
      return this.$store.getters['purchases/module']
    },
    purchases: function () {
      return this.$store.getters['purchases/items']
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['purchasesSubmitted']
    },
    totalAmount: function () {
      let source = null
      if (this.currentFile !== this.allFiles[0].filename) {
        source = this.currentFile
      }
      let validPurchases = this.$store.getters['purchases/allItems'](source).filter(obj => obj.score !== 2 && obj.module === Purchase.MODULE_NAME)
      return validPurchases.map(obj => obj.amount).reduce((a, b) => parseFloat(a) + parseFloat(b), 0.0).toFixed(0)
    },
    totalOtherModules: function () {
      let source = null
      if (this.currentFile !== this.allFiles[0].filename) {
        source = this.currentFile
      }
      return this.$store.getters['purchases/otherModulesItems'](source).length
    },
    totalInvalid: function () {
      let source = null
      if (this.currentFile !== this.allFiles[0].filename) {
        source = this.currentFile
      }
      return this.$store.getters['purchases/invalidItems'](source).length
    },
    totalValid: function () {
      let source = null
      if (this.currentFile !== this.allFiles[0].filename) {
        source = this.currentFile
      }
      return this.$store.getters['purchases/validItems'](source).length
    },
    modalTitle: function () {
      let title = this.$t('modal-title-1')
      if (this.modeCreation) {
        title = this.$t('modal-title-2')
      } else if (this.submitted) {
        title = this.$t('modal-title-3')
      }
      return title
    }
  },
  watch: {
    dropFile: function () {
      if (this.dropFile) {
        let allFilesNames = this.allFiles.map(obj => obj.filename)
        if (!allFilesNames.includes(this.dropFile.name)) {
          this.$store.commit('purchases/ERREUR', '')
          this.$store.commit('purchases/ISMODIFIED', true)
          let reader = new FileReader()
          let self = this
          reader.onload = function (event) {
            let [data, headerMap, error] = self.loadFile(event.target.result)
            if (error === 'ok') {
              for (let line of data) {
                if (line[headerMap.icode] && line[headerMap.iamount]) {
                  self.$store.dispatch('purchases/add', {
                    'id': null,
                    'code': line[headerMap.icode],
                    'amount': line[headerMap.iamount],
                    'source': self.dropFile.name
                  })
                }
              }
              self.allFiles.push({
                'filename': self.dropFile.name
              })
              self.currentFile = self.dropFile.name
            } else if (error === 'bad separator') {
              self.$buefy.dialog.alert({
                title: self.$t('message-1'),
                message: self.$t('message-2')
              })
            } else {
              self.$buefy.dialog.alert({
                title: self.$t('message-3'),
                message: self.$t('message-4')
              })
            }
            self.forceComputation()
          }
          reader.readAsText(this.dropFile)
        } else {
          this.$buefy.dialog.alert({
            title: this.$t('message-5'),
            message: this.$t('message-6')
          })
        }
      }
    }
  },
  methods: {
    validate: function () {
      let self = this
      if (this.$store.getters['purchases/invalidItems'](null).length !== 0) {
        this.$buefy.dialog.confirm({
          title: self.$t('title-2'),
          message: self.$t('info-9'),
          confirmText: self.$t('validate'),
          cancelText: self.$t('cancel'),
          canCancel: ['escape', 'button', 'outside'],
          onConfirm: function () {
            self.$store.dispatch('purchases/deleteInvalidItems')
            self.subValidate()
          }
        })
      } else {
        this.subValidate()
      }
    },
    subValidate: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('purchases/savePurchases')
          .then(data => {
            loadingComponent.close()
            if (this.purchases.length === 0) {
              this.$store.commit('purchases/ISVALID', false)
            } else {
              this.$store.commit('purchases/ISVALID', true)
            }
            this.$store.commit('purchases/ERREUR', '')
            this.$store.commit('purchases/ISMODIFIED', false)
            this.allFiles = [
              {
                'filename': this.$t('label-5')
              }
            ]
            this.currentFile = this.allFiles[0].filename
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg')
            })
          })
          .catch((erreur) => {
            loadingComponent.close()
            this.$store.commit('purchases/ISVALID', false)
            this.$store.commit('purchases/ERREUR', erreur.response.data)
          })
      } else {
        if (this.purchases.length === 0) {
          this.$store.commit('purchases/ISVALID', false)
        } else {
          this.$store.commit('purchases/ISVALID', true)
        }
        this.$store.commit('purchases/ISMODIFIED', false)
      }
    },
    closeModal: function () {
      this.displayModal = false
      this.purchase = new Purchase(null, '', 0)
    },
    add: function (purchase) {
      this.$store.dispatch('purchases/add', purchase)
      this.$store.commit('purchases/ISMODIFIED', true)
      this.closeModal()
      this.forceComputation()
    },
    update: function (obj) {
      this.$store.dispatch('purchases/update', obj)
      this.$store.commit('purchases/ISMODIFIED', true)
      this.closeModal()
      this.forceComputation()
    },
    del: function () {
      let self = this
      let msg = this.$t('message-8') + ' <strong>' + this.currentFile + '</strong> ?'
      let source = this.currentFile
      if (this.currentFile === this.allFiles[0].filename) {
        msg = this.$t('message-9')
        source = null
      }
      this.$buefy.dialog.confirm({
        title: self.$t('message-7'),
        message: msg,
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('purchases/deleteSource', source)
          self.$store.commit('purchases/ISMODIFIED', true)
          if (source) {
            let index = self.allFiles.findIndex(obj => obj.filename === source)
            self.allFiles.splice(index, 1)
          } else {
            self.allFiles = [
              {
                'filename': self.$t('label-5')
              }
            ]
          }
          self.currentFile = self.$t('label-5')
          self.forceComputation()
        }
      })
    },
    edit: function (purchase) {
      this.modeCreation = false
      this.purchase = purchase
      this.displayModal = true
    },
    displayAddForm: function () {
      this.modeCreation = true
      this.purchase = new Purchase(null, '', 0)
      this.displayModal = true
    },
    forceComputation: function () {
      this.$refs.purchasesWarning.forceComputation()
    }
  }
}
</script>
